<?php
namespace Geral\Repositories;

class Localestoque extends \Doctrine\ORM\EntityRepository
{


    /**
     * Consulta todos os almoxarifados e localizações de uma filial.
     *
     * @param $nrorg
     * @param $filial
     *
     * @return bool|mixed
     */
    public function consultaAlmoxarifadoLocalizacaoPorFilial($nrorg, $filial){
        $sql = "SELECT L.*
                  FROM LOCALESTOQUE L, PARAMFILIAL P
                 WHERE L.NRORG = :P_NRORG
                   AND L.CDFILIAL = :P_CDFILIAL
                   AND L.NRORG = P.NRORG
                   AND L.CDFILIAL = P.CDFILIAL
                   AND P.IDUTILLCESTQ = 'S'
                   AND L.CDALMOXARIFE <> ' '
                   AND L.CDLOCALESTOQ <> ' '
                UNION
                SELECT L.*
                  FROM LOCALESTOQUE L, PARAMFILIAL P
                 WHERE L.NRORG = :P_NRORG
                   AND L.CDFILIAL = :P_CDFILIAL
                   AND L.NRORG = P.NRORG
                   AND L.CDFILIAL = P.CDFILIAL
                   AND P.IDUTILLCESTQ <> 'S'
                   AND L.CDALMOXARIFE <> ' '
                   AND L.CDLOCALESTOQ  = ' '
                ORDER BY 1, 2, 3";

        $params = array(
            "P_NRORG" => $nrorg,
            "P_CDFILIAL" => $filial,
        );

        $entityManager = $this->getEntityManager();
        $resultSetMapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entityManager);
        $resultSetMapping->addRootEntityFromClassMetadata('Geral\Entities\Localestoque', "L");

        $result = $entityManager->createNativeQuery($sql, $resultSetMapping)->execute($params);
        return count($result)>0 ? $result : false;
    }

}